#include <u.h>
#include <libc.h>
#include <bio.h>
#include "irc.h"


char *
getln(Sess *s)
{
	int n;
	char *p;
	if((p = Brdline(s->bi, '\n')) == nil)
		return nil;
	n = Blinelen(s->bi) -2;
	p[n] = 0;
	if (Debug)
		fprint(2, "rx: %s\n", p);
	return p;
}

int
putln(Sess *s, char *fmt, ...)
{
	int n;
	va_list arg;

	va_start(arg, fmt);
	lock(&s->netlock);
	n = Bvprint(s->bo, fmt, arg);
	Bputc(s->bo, '\r');
	Bputc(s->bo, '\n');
	Bflush(s->bo);
	if (Debug){
		fprint(2, "tx: ");
		vfprint(2, fmt, arg);
		fprint(2, "\n");
	}
	unlock(&s->netlock);
	va_end(arg);
	s->lasttx = time(nil);

	return n;
}
