#include <u.h>
#include <libc.h>
#include <bio.h>
#include <ctype.h>
#include "irc.h"
#include "irccodes.h"

void message(Sess *, char *, char *, char *, int);

struct chatter {
	char *src;
	char *dst;
	char *msg;
} chatter[] = {
//	:service!name@host  NOTICE username :message ...
//	SERVICE		USERNAME	MESSAGE
	{ nil,		"*",		"*** looking up your hostname" },
	{ nil,		"*",		"*** your host is " },
	{ nil,		"*",		"*** found your hostname" },
	{ nil,		"*",		"*** checking ident" },
	{ nil,		"*",		"*** no ident response" },
	{ nil,		"#plan9",	"[freenode-info] please register your nickname" },

	{ "nickserv",	nil,		"This nickname is registered." },
	{ "nickserv",	nil,		"You are now identified" },
	{ "memoserv",	nil,		"you have no new" },
	{ "memoserv",	nil,		"you have no new" },
};

struct {
	char *who;
	char *word;
} swear[] = {
	{ "uriel",	"fuck" },
	{ "uriel",	"shit" },
	{ "uriel",	"arse" },
};

void
br(Sess *s)
{
	*s->partners = 0;
	Bprint(bout, "\n");
}

int
isrude(char *src, char *msg)
{
	int i;

	for (i = 0; i < nelem(swear); i++){
		if ((!swear[i].who || cistrcmp(swear[i].who, src) == 0) &&
		    cistrstr(msg, swear[i].word) != 0)
			return 1;
	}
	return 0;
}

int
ischatter(char *src, char *dst, char *msg)
{
	int i;

	for (i = 0; i < nelem(chatter); i++)
		if ((!chatter[i].src || cistrcmp(chatter[i].src, src) == 0) && 
		    (!chatter[i].dst || cistrcmp(chatter[i].dst, dst) == 0) &&
		    cistrncmp(chatter[i].msg, msg, strlen(chatter[i].msg)-1) == 0)
			return 1;

	return 0;
}

void
idlemark(Sess *s)
{
	if (s->lastpr && time(nil) - s->lastpr > Idlesec){
		br(s);
		Bprint(bout, "—————— %ldm\n", ((time(nil) - s->lastpr)+30) / 60);
	}
}


void
checkaway(Sess *s)
{
	Dir *d;

	if((d = dirstat("/dev/mouse")) == nil)
		sysfatal("/dev/mouse - cannot stat - %r\n");
	if(! s->away && (time(nil) - d->atime) > 5*60){
		s->away = 1;
		putln(s, "away :away\r\n");
		br(s);
		Bprint(bout, "⋯\n");
		Bflush(bout);
	}
	if(s->away && (time(nil) - d->atime) < 5*60){
		s->away = 0;
		putln(s, "away\r\n");
		Bflush(bout);
	}
}

void
message(Sess *s, char *from, char *to, char *msg, int action)
{
	int private, n, i, l;
	char *p, *a[512];
	char partners[sizeof(s->partners)];

	if ((p = strrchr(msg, 0)) == msg)
		return;
	p -= 1;
	if (*msg == '\001' && *p == '\001'){
		*p = 0;
		msg++;
		ctcp_hand(s, from, to, msg);
		return;
	}

	idlemark(s);
	private = (irccmp(to, s->current->name) != 0 &&
		irccmp(from, s->current->name) != 0);

	snprint(partners, sizeof(partners), "%s %s", from, to);
	if (irccmp(s->partners, partners) != 0){
		Bprint(bout, "\n");
		if (*from){
			if (private)
				Bprint(bout, "▏%s\n", from);
			else
				Bprint(bout, "%s\n", from);
		}
	}

	i = 0;
	n = getfields(msg, a, sizeof(a), 0, " \t"); 
	do {
		if (private)
			Bprint(bout, "▏");
		Bprint(bout, "\t%s", (action)? "«": "");
		l = 0;
		while(i < n){
			Bprint(bout, "%s", a[i]);
			l += strlen(a[i]) +1;
			i++;
			if (l > Wraplen)
				break;
			if (i < n)
				Bprint(bout, " ");
		}	
		Bprint(bout, "%s\n", (action)? "»": "");
	}while (i < n);

	s->lastpr = time(nil);
	strcpy(s->partners, partners);
}

static int
parsecmd(char *s, char **args, int nargs)
{
	int n;
	char *p, *t;
 
	for (n = 0; n < nargs; n++)
		args[n] = "";

	if (*s == ':'){
		t = s+1;
		if ((p = strchr(t, ' ')) != nil){
			*p++ = 0;
			s = p;
		}
		if ((p = strchr(t, '!')) != nil){
			*p++ = 0;
			args[0] = t;
			t = p;
		}
		if ((p = strchr(t, '@')) != nil){
			*p++ = 0;
			args[1] = t;
			t = p;
		}
		else
		if ((p = strchr(t, '%')) != nil){
			*p++ = 0;
			args[1] = t;
			t = p;
		}
		args[2] = t;
	}

	for (n = 3; n < nargs; n++){
		while (*s == ' ')
			*s++ = 0;
		if (! *s)
			break;
		if (*s == ':'){
			args[n++] = s+1;
			break;
		}
		args[n] = s;
		while(*s && *s != ' ')
			s++;
	}
	return n;
}

int
cmdid(char *cmd)
{
	int i;
	struct {
		char *s;
		int n;
	} tab[] = {
		{ "join",	Cjoin },
		{ "quit",	Cquit },
		{ "part",	Cpart },
		{ "ping",	Cping },
		{ "privmsg",	Cprivmsg },
		{ "notice",	Cnotice },
		{ "nick",	Cnick },
		{ "mode",	Cmode },
		{ "topic",	Ctopic },
		{ "error",	Cerror }
	};

	for(i = 0; i < nelem(tab); i++)
		if(cistrcmp(cmd, tab[i].s) == 0)
			return tab[i].n;

	if (isdigit(*cmd))
		return strtod(cmd, nil);

	fprint(2, "%q - cmd unknown\n", cmd);
	return 0;
}

void
netread(Sess *s)
{
	int i, n, m;
	char *p, *str, *a[64], *args[64];

	while(str = getln(s)){
		checkaway(s);

		if ((n = parsecmd(str, args, nelem(args))) < 4)
			continue;

		if (Debug > 1){
			fprint(2, "	");
			for (i = 0; i < n; i++)
				fprint(2, "arg%d='%s' ", i, args[i]);
			fprint(2, "\n");
		}

		switch(cmdid(args[3])){
		case Cerror:
			br(s);
			Bprint(bout, "ERROR\t");
			for (i = 0; i < n; i++)
				Bprint(bout, "%d %s ", i, args[i]);
			Bputc(bout, '\n');
			break;
		case Cping:
			/* Freenode, contrary to the RFC, insists on upper case */
			if (n > 5)
				putln(s, "PONG %s %s", args[4], args[5]);
			else
				putln(s, "PONG %s", args[4]);
			break;
		case Cjoin:
			if(strcmp(args[0], s->nick) != 0)
				Bprint(bout, "\n+%s\n", args[0]);
			user_add(s, args[0], args[1], args[2]);
			user_last(s, args[0], time(nil));
			nick_add(s->current, args[0]);
			putln(s, "whois %s\r\n", args[0]);
			*s->partners = 0;
			break;
		case Cquit:	// drop message - never seen anything useful
			br(s);
			Bprint(bout, "-%s\n", args[0]);
			user_del(s, args[0]);
			nick_del(s->current, args[0]);
			break;
		case Cpart:	// drop message - never seen anything useful
			br(s);
			Bprint(bout, "-%s\n", args[0]);
			nick_del(s->current, args[0]);
			user_last(s, args[0], time(nil));
			break;
		case Cnotice:
			if (ischatter(args[0], args[4], args[5]))
				break;
			message(s, args[0], args[4], args[5], 0);
			user_last(s, args[0], time(nil));
			user_away(s, args[0], nil);
			break;
		case Cprivmsg:
			if(isrude(args[0], args[5]))
				message(s, args[0], args[4], "≡☹≡", 0);
			else
				message(s, args[0], args[4], args[5], 0);
			if(user_unknown(s, args[0]))
				putln(s, "whois %s\r\n", args[0]);
			user_last(s, args[0], time(nil));
			user_away(s, args[0], nil);
			break;
		case Cnick:
			user_newnick(s, args[0], args[4]);
			br(s);
			Bprint(bout, "%s ⇒ %s\n", args[0], args[4]);
			break;
		case Cmode:
			break;
		case Ctopic:
			m = getfields(args[5], a, nelem(a), 0, "|");
			br(s);
			for (i = 0; i < m; i++){
				for(p = a[i]; isspace(*p); p++)
					continue;
				Bprint(bout, "topic: %s\n", p);
			}
			break;
		case Raway:
			if (n >= 7)
				user_away(s, args[5], args[6]);
			break;
		case Rwhoisuser:
			if (n >= 10)
				user_really(s, args[5], args[9]);
			break;
		case Rwhoisserver:
			if (n >= 7)
				user_where(s, args[5], args[7]);
			break;
		case Rwhoisidle:
			if (n >= 7)
				user_last(s, args[5], time(nil)-strtol(args[6], nil, 10));
			break;
		case Rwhoischannels:
//			for (i = 6; i < n; i++)
//				user_chan(s, a[i]);
			break;
		case Rtopic:
			m = getfields(args[6], a, nelem(a), 0, "|");
			br(s);
			for (i = 0; i < m; i++){
				for(p = a[i]; isspace(*p); p++)
					continue;
				Bprint(bout, "topic: %s\n", p);
			}
			break;
		case Rtopicinfo:
			if (n >= 8){
				br(s);
				Bprint(bout, "\nowner: %s  %s",
				    args[6], ctime(strtol(args[7], nil, 10)));
			}
			break;
		case Rwhoreply:
			if (n >= 12){
				nick_add(s->current, args[9]);
				user_add(s, args[9], args[6], args[7]);
				if (strlen(args[11]) > 2){
					p = strrchr(args[13]+2, '"');
					if(args[13][2] == '"' && p != nil){
						*p = 0;
						user_really(s, args[9], args[11]+3);
					}
					else
						user_really(s, args[9], args[11]+2);
				}
			}
			break;
		case Rnamreply:
			m = tokenize(args[7], a, nelem(a));
			for (i = 0; i < m; i++)
				nick_add(s->current, a[i]);
			break;
		case Rserveroverload:		// server is overload, command dropped
			br(s);
			Bprint(bout, "?\tserver overload: %s\n", args[5]);
			break;
		case Enosuchnick:
			br(s);
			Bprint(bout, "?\t%s - nick not known\n", args[5]);
			break;
		case Rendofmotd:
			if(! ischan(s->current->name)){
				nick_add(s->current, s->current->name);
				putln(s, "whois %s\r\n", s->current->name);
			}
			break;
		case Enotregistered:
			break;
		case Eneedreggednick:
			break;
		default:	// failed  & invalid errors
			if (*args[3] == '4' || *args[3] == '5'){
				br(s);
				Bprint(bout, "?\t");
				for (i = 0; i < n; i++)
					Bprint(bout, "%s ", args[i]);
				Bputc(bout, '\n');
			}
			break;
		}
		Bflush(bout);
	}
}

void
consread(Sess *s)
{
	Biobuf b, *bp = &b;
	char *action, *p, *str;

	action = "«";
	Binit(bp, 0, OREAD);

	while(str = Brdline(bp, '\n')){
		str[Blinelen(bp) -1] = 0;

		*s->partners = 0;
		checkaway(s);

		if (strcmp(str, "?") == 0){
			p = user_list(s);
			Bprint(bout, "%s", p);
			Bflush(bout);
			free(p);
			continue;
		}
		if (*str == 0){
			idlemark(s);
			Bflush(bout);
			s->lastpr = time(nil);
			continue;
		}
		if (memcmp(str, action, utflen(action)) == 0){
			str += utflen(action);
			putln(s, "privmsg %s :\001ACTION %s\001\r\n", s->current->name, str);
		}
		else{
			putln(s, "privmsg %s :%s\r\n", s->current->name, str);
		}
		s->lastpr = time(nil);
		user_last(s, s->nick, time(nil));
		*s->partners = 0;
	}
}
