#include <u.h>
#include <libc.h>
#include <bio.h>
#include "irc.h"

void
nick_add(Chan *c, char *nick)
{
	Nick *n;
	for (n = c->nicks; n; n = n->next)
		if (strcmp(n->nick, nick) == 0)
			return;
	n = ecalloc(1, sizeof(Nick));
	n->nick = estrdup(nick);
	n->next = c->nicks;
	c->nicks = n;		
}

void
nick_del(Chan *c, char *nick)
{
	Nick *p, *n;
	for (p = nil, n = c->nicks; n; p = n, n = n->next)
		if (strcmp(n->nick, nick) == 0){
			if (p)
				p->next = n->next;
			else
				c->nicks = n->next;
			free(n->nick);
		}
}

char *
nick_list(Chan *c)
{
	Nick *n;
	Fmt fmt, *f = &fmt;

	fmtstrinit(f);
	for (n = c->nicks; n; n = n->next)
		fmtprint(f, "%s\n", n->nick);
	return fmtstrflush(f);
}

