#include <u.h>
#include <libc.h>
#include <bio.h>

char *
estrdup(char *p)
{
	if ((p = strdup(p)) == nil)
		sysfatal("no memory\n");
	return p;
}

void *
ecalloc(int n, int m)
{
	void *p;
	if ((p = calloc(n, m)) == nil)
		sysfatal("no memory\n");
	return p;
}

char *
strpfx(char *s, char *t)
{
	int n = strlen(t);
	if (strncmp(s, t, n) == 0)
		return s+n;
	return nil;
}

char *
realname(char *user)
{
	Biobuf *bp;
	char *line, *a[16];

	if ((bp = Bopen("/adm/keys.who", OREAD)) == nil)
		sysfatal("/adm/keys.who - cannot open");
	while ((line = Brdline(bp, '\n')) != nil){
		line[Blinelen(bp) -1] = 0;
		if (getfields(line, a, nelem(a), 0, "|") < 3)
			continue;
		if (strcmp(a[0], user) == 0){
			Bterm(bp);
			return estrdup(a[2]);
		}
	}
	Bterm(bp);
	return "Unknown user";
}

